 /////////////////////////////////////////////////////////////////////////////
// @doc EllipseObj
// @module EllipseObj.Java | Implementation of the <c EllipseObj> class.
// 
// Rosa2000 Applet<tm>
// <nl>Copyright <cp> 1999, 2000, DM Solutions Group Inc. All rights reserved.
// 
// Author:  Guy Parent
//
// $Id: EllipseObj.java,v 1.3 2000/08/22 15:25:13 assefa Exp $
// 
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1999, 2000, DM Solutions Goup Inc.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
// DEALINGS IN THE SOFTWARE.
/////////////////////////////////////////////////////////////////////////////
// $Log: EllipseObj.java,v $
// Revision 1.3  2000/08/22 15:25:13  assefa
// Change a bit the way the ellipse is drawn : start at the middle.
//
// Revision 1.2  2000/04/06 11:26:19  gparent
// Fixed a drawing bug using default selection
//
// Revision 1.1  2000/01/28 20:16:30  daniel
// Initial Revision
//
/////////////////////////////////////////////////////////////////////////////

import java.awt.Graphics;
import java.awt.Color;                      

/** 
 * This class inherit from RectObj. It responsible to draw an ellipse.
 *
 * @author  Guy Parent
 */
public class EllipseObj extends RectObj
{
  /**
   * Constructor.
   */
  public EllipseObj( Map parent )
  {
    super( parent );
  }

  /**
   * Draw an ellipse at the xy coordinate.
   */
  public  void draw ()
  {
    if( g == null )      g = m_map.getGraphics();    if (g != null)
    {
      Color colorCurrent = g.getColor();
      g.setColor( this. getColor());
      g.drawOval( x -width,  y-height,  width*2,  height*2);      
      g.setColor( colorCurrent );
    }
  }
}
