/////////////////////////////////////////////////////////////////////////////
// @doc Rosa2000
// @module Rosa2000.Java | Implementation of the <c Rosa2000> class.
// 
// Rosa2000 Applet<tm>
// <nl>Copyright <cp> 1999, 2000, DM Solutions Group Inc. All rights reserved.
// 
// Author:  Guy Parent
//
// $Id: Rosa2000.java,v 1.22 2002/08/20 14:53:50 assefa Exp $
// 
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1999, 2000, DM Solutions Goup Inc.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
// DEALINGS IN THE SOFTWARE.
/////////////////////////////////////////////////////////////////////////////
// $Log: Rosa2000.java,v $
// Revision 1.22  2002/08/20 14:53:50  assefa
// Note on PNG support.
//
// Revision 1.21  2002/08/19 20:31:43  assefa
// Add ability to set the pixel size parameter from javascript.
//
// Revision 1.20  2002/08/08 15:37:56  sacha
// Put back toolba button when printing but not for Netscape. I still have a problem in netscape. So I just removed the toolbar in Netscape when printing.
//
// Revision 1.19  2002/08/07 19:23:51  sacha
// When printing in Netscape, the main map was stretched by browser. It is documented on the web that Netscape is Larger than the original applet dimension. We must resize it by 75% before displaying it.
//
// Revision 1.18  2001/09/11 21:19:33  assefa
// Remove test code.
//
// Revision 1.17  2001/09/11 20:29:41  assefa
// Add PNG support.
//
// Revision 1.16  2001/08/24 14:34:20  assefa
// Change version date.
//
// Revision 1.15  2001/07/20 17:06:38  assefa
// Correct bug that appeared with IE5.5 : the applet seems to
// not be initialized properly.
//
// Revision 1.14  2001/05/16 20:35:00  assefa
// Add version display when applet starts.
//
// Revision 1.13  2001/05/16 18:37:42  assefa
// Clean up tooltip threads.
//
// Revision 1.12  2000/11/03 18:13:07  assefa
// Increase buffer size used in SetMapInformation method.
//
// Revision 1.11  2000/10/18 19:55:13  assefa
// Add call to set the button image in method setSelectedButton.
//
// Revision 1.10  2000/10/17 21:29:43  assefa
// Add more output in debug mode.
//
// Revision 1.9  2000/10/11 17:10:55  assefa
// Add methods SetMapInformations to be able to modify the applet's image.
// Add public utility methods setButtonPress and getButton accessible to be
// able to press a button.
//
// Revision 1.8  2000/09/19 21:58:24  assefa
// Add get method to return Map object.
//
// Revision 1.7  2000/08/18 20:07:05  assefa
// Correct the loading message.
//
// Revision 1.6  2000/06/09 16:53:56  daniel
// Added bIgnoreSubmit param to startAction() to prevent infinite loop
//
// Revision 1.5  2000/04/06 11:30:22  gparent
// Removed some comments
//
// Revision 1.3  2000/03/30 03:16:41  gparent
// Added the default button.
//
// Revision 1.2  2000/03/30 02:15:50  gparent
// Trap an exception when a parameter is missing inthe javascript
//
// Revision 1.1  2000/01/28 20:16:30  daniel
// Initial Revision
//
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////
// Import Modules.
import java.applet.Applet;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Color;
import java.awt.BorderLayout;
import java.io.IOException;
import java.lang.Integer;
import java.lang.NumberFormatException; 
import java.awt.Rectangle;
import java.awt.Component;
import java.net.URL;
import java.awt.Cursor;

import java.net.MalformedURLException;

import java.awt.Toolkit;

import java.awt.Graphics;

import java.awt.Panel;

import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Window;
import java.awt.Label;
import java.awt.Point;
import java.awt.TextArea;
//import java.awt.Panel;
import java.io.InputStream;

import java.util.StringTokenizer;
import netscape.javascript.*;

import java.net.URLConnection;

/* ==================================================================== */
/*      PNG support. Please comment this block of code if you do not    */
/*      need PNG support.                                               */
/* ==================================================================== */
import com.sixlegs.image.png.*;
/* ==================================================================== */
/*      End of PNG suuport                                              */
/* ==================================================================== */



// ********************************************************
// Class Rosa2000       // font verdana
// ********************************************************
/**
 * Rosa2000 is the entry point of the applet.  This object initialize the map 
 * and the toolbar.  This applet was develop to show an image and associate
 * some operation to apply on it.  In setting some <a href="http://www.dmsolutions.on.ca/rosa/rosa_params.html">
 * parameters</a>,  you could customize the applet to do any operation you need.
 * By example, you could associate a button and a rectangle operation. You could
 * automaticaly submit the coordinate etc.  See the web page above for the
 * specific parameters.
 * 
 * @autor Guy Parent
 */
public class Rosa2000 extends Applet  
{
  //Constant Parameters names.
  /** Position toolbar parameter name  */
  private final String kstrTbSelectedButton	= "TB_SELECTED_BUTTON";
  /** Position toolbar parameter name  */
  private final String kstrTbPositionName   = "TB_POSITION";
  /** Location toolbar parameter name  */
  private final String kstrTbLocationName   = "TB_LOCATION";
  /** Toolbar alignement parameter name    */
  private final String kstrTbAlignName      = "TB_ALIGN";
  /** Image URL parameter name     */
  private final String kstrImgListName      = "IMG_URL";
  /** X scaling parameter name     ( not used yet ) */
  private final String kstrXScaleName       = "X_SCALE";
  /** X scaling parameter name     ( not used yet ) */
  private final String kstrYcaleName        = "Y_SCALE";
  /** Backgournd color parameter name  */
  private final String kstrBkColorName      = "BG_COLOR";
  /** List of button parameter name    */
  private final String kstrButtonDefName    = "TB_BUTTONS";
  /** Debug info parameter name    */
  private final String kstrDebugModeName    = "DEBUG";

    /** Form name parameter  */
  private final String kstrFormParam     = "INP_FORM_NAME";

  // Loading message...
  /** Loading message parameter name   */
  private final String kstrLoadingMsg       = "LOADING_MSG";
  /** Default loading message.     */
  private final String kstrDefaultLoadingMsg= null;

    //buffer size for SetMapInformation method
    public int m_gBufferSizeForStream = 5000;

  // Static Variable
  /** If <b>true</b> all debug information will be show in the java consol     */
    public static boolean m_bIsDebug          = false;

  /** Defaut width of the loading message.	 */
    private int m_nWidthOfLoadingWnd = 400;
  /** Defaut height of the loading message.	 */
    private int m_nHeightOfLoadingWnd = 100;

    private double      mdfPixelSize = 0;
  
  // Attributs
  /** Toolbar object   */
  ToolbarPanel        m_toolbar           = null;
  /** Map object. This object manage the image and apply all operation */
  Map                 m_map               = null;

  /** Used to draw the loading message.  */
  private String      m_strLoadingString  = null;
  
  /** This member is used to know when the loading processing is completed.    */
  boolean             m_bLoad					    = false;

  /** Show the loading message	 */
  Frame				        m_Frame					    = null;
  Label					      m_status					  = null;
  // ================================================================
  // Initialisation methods.
  // ================================================================
  //////////////////////////////////////////////////////////
  /**
   * Initialize the applet. Load the toolbar and the map.
   */ 
  public void init()
  {
    // Read the debug param.
    readDebugParam();       
    
    // Set a loading message.
    m_strLoadingString = getParameter( kstrLoadingMsg );
    if (m_strLoadingString == null)
      m_strLoadingString  = "Loading map... Please wait.";

    // Create the applet components.
    setLayout( null );
    loadBackground();

    // Set visible to allow the loading text to draw.
    setVisible( true );
    
    // Create and show the message window
    //showLoadingMessage();

    paint(getGraphics());   

    // Loading processing
    setLoadingMsg("Loading Map..." );
    
    // Loading processing   
    loadMap(null);

    //read the pixel size parameter if set
    String strPixelSize = getParameter("PIXEL_SIZE");
    if( strPixelSize != null )
    {
        try
        {
            mdfPixelSize = Double.valueOf( strPixelSize ).doubleValue();
        }
        catch( NumberFormatException e )
        {
            mdfPixelSize = 1.0;
        }
    }
    else
        mdfPixelSize = 1.0;
  
    System.out.println("init");
  }

  /////////////////////////////////////////
  // static methods.
  /**
   * Determine if the debug info is enable.
   * @return <b>true</b> if enable.
   */
  static public boolean isDebugMode()
  {
      //return true;
      return m_bIsDebug;
  }
  
  /////////////////////////////////////////
  /**
   * Return the toolbar object.
   */
  public ToolbarPanel getTB()
  {
    return m_toolbar;
  }
  
    /////////////////////////////////////////
    /**
     * Return the toolbar object.
     */
    public Map getMapObj()
    {
        return m_map;
    }
  /** Called by the browser or applet viewer to inform this applet that it should 
   * start its execution. It is called after the init method and each time the applet 
   * is revisited in a Web page.  It reset the command.
   * @see Applet#stop
   */
  public void stop()
  {
    m_map.destroyCommand();
    m_toolbar.setButtonPress( null );
    m_toolbar.cleanUp();
    System.out.println("stop");
  }

  public void start()
  {
 
      setSelectedButton();
      System.out.println("start : Development Version 2001-09-11");
  }
  
  
  //////////////////////////////////////////////////////////
  // Set the BackGround
  /**
   * Load the background color parameter.  The background color must be
   * on 24bits in hexa. Ex: FFFFFF. The caracter # is supported in prefix but
   * it's not used. <BR><BR>The default color is white (FFFFFF).
   */
  protected void loadBackground()
  {
    // Get the color
    String strColorName = getParameter( kstrBkColorName );
    int nColor = 0xFFFFFF;
    if( strColorName != null )
    {
      try
      {
        // if the color begin with #, just remove it
        if( strColorName.startsWith( "#" ) == true )
          strColorName = strColorName.substring( 1 );
        nColor = Integer.valueOf( strColorName, 16 ).intValue();
      }
      catch( NumberFormatException e )
      {
        System.err.println( "Invalid background color: " + strColorName );
        return;
      }
    }
    setBackground(new Color( nColor ) );
    
  } // End loadBackground

  //////////////////////////////////////////////////////////
  // Set the debug
  /**
   * Read the debug parameter.  To enable the debug mode, the supported value
   * is 1. Ex:&lt;PARAM NAME="DEBUG" VALUE="1"&gt; Otherwise, the debug mode
   * will be disable.
   */
  protected void readDebugParam()
  {
    // Get the debug info
    String strDebug = getParameter( kstrDebugModeName );
    if( strDebug != null )
    {
      try
      {
        m_bIsDebug = (Integer.valueOf( strDebug, 10 ).intValue() == 1);
      }
      catch( NumberFormatException e )
      {
        System.err.println( "Invalid debug info: " + strDebug );
        return;
      }
    }
  } // End loadBackground
  
  //////////////////////////////////////////////////////////
  // Load the map
  /**
   * Load the map.  This method try to loading the image in IMG_URL parameter
   * and if the image load fine, it create a new Map object to manage the image.
   * 
   */
  public void loadMap(String strMap)
  {  
//      System.out.println("loadMap");

      String    strCurrentButtonName = null;

      if (m_toolbar != null && m_toolbar.getCurrentButton() != null)
      {
          strCurrentButtonName = m_toolbar.getCurrentButton().getButtonName();
      }


      m_bLoad = false;
      
      if (m_map != null)
        remove(m_map);
      
      m_map = null;

      if (m_toolbar != null)
        remove(m_toolbar);
               
      m_toolbar = null;

      paint(getGraphics());   

      loadImage(strMap);

      setLoadingMsg("Loading toolbar..." );
      readToolbarParam();

      add( m_map );
      add( m_toolbar );
    
      m_toolbar.automaticPlace();
    
    // The applet is ok to draw.
      m_bLoad = true;

    // Destroy the loading window
      destroyLoadingMsg();

      repaint();

    // Set all stuff visible
    m_map.setVisible( true );
    m_toolbar.setVisible( true );

    if (strCurrentButtonName != null && m_toolbar != null)
      setButtonPress(strCurrentButtonName);

  }

  //////////////////////////////////////////////////////////
  // Load the image
  /**
   * Load the image.  This method try to loading the image in IMG_URL parameter
   * and if the image load fine, it create a new Map object to manage the image.
   * 
   */
  protected void loadImage(String strMap)
  {
      if (isDebugMode())
        System.out.println("loadimage = " + strMap);

      String strMapName = null;

      m_bLoad = false;
      if (strMap == null)
        strMapName = getParameter( kstrImgListName );
      else
        strMapName = strMap;

      if (strMap != null)
        repaint();

      try
      {   
          // Get the address
          Image mapImg = null;
          // Check if the address is an url.
          URL url = null;
          try
          {
              url = new URL( strMapName );
              mapImg = getImage( url );
          }
          catch(MalformedURLException e)
          {
              System.out.println("1st");
              try
              {
                  url =  getDocumentBase();
                  mapImg = getImage(url, strMapName );
                  int nWidth = mapImg.getWidth(this); 
                  System.out.println(nWidth);
              }
              catch(Exception ex)
              {
                  System.out.println("2nd");
              }
          }
          
          // create a MediaTracker
          MediaTracker theTracker = new MediaTracker(this);
          theTracker.addImage(mapImg,0);
          theTracker.waitForAll();
          // Check the errors.

/* ==================================================================== */
/*      PNG support. Please comment this block of code if you do not    */
/*      need PNG support.                                               */
/* ==================================================================== */
          if (theTracker.isErrorAny())
          {
              System.out.println("Try as PNG");
              try
              {
                  url =  new URL(getDocumentBase(), strMapName);
              }
              catch(MalformedURLException e)
              {     
                  System.err.println( "Cannot load the map " + url);    
              }
      
              try 
              { 
                  PngImage png = new PngImage(url);
                  mapImg = Toolkit.getDefaultToolkit().createImage(png);
              }
              catch (Exception ex) 
              { 
                  System.err.println(ex); 
              }

          }
/* ==================================================================== */
/*      End of PNG suuport                                              */
/* ==================================================================== */
          

/* ==================================================================== */
/*      This is to make sure that the applet is initialized             */
/*      correctly. On IE5.5 and heigher it seems some times that the    */
/*      applet is not initialized yet when we get to this point. So     */
/*      after loading the image from the server, we will wait until     */
/*      the applet is ready. I am not sure about what is going on       */
/*      exaclty ;) AY 2001/07                                           */
/* ==================================================================== */
          while (this.getBounds().width <= 0)
          {
          }

      // Create the map
          if (m_map != null)
            remove(m_map);
          m_map = new Map( this, mapImg, mapImg.getWidth( this ), mapImg.getHeight( this )  );

      }
      catch(Exception e)
      {
          System.err.println("Error loading image.");
          System.exit(1);
      }

  } // End loadImage
    
    /**
   * Load the toolbar. Read the location and initialize the toolbar.
   */
  protected void readToolbarParam()
  {
    // Read the position.
    String strToolbarPosition = getParameter( kstrTbPositionName );
    if( strToolbarPosition == null )
      strToolbarPosition = "right";
    
    String strToolbarAlignment = getParameter( kstrTbAlignName );

    m_toolbar = new ToolbarPanel( this, m_map, strToolbarPosition, strToolbarAlignment );

    readButton();
  }
  
  /**
   * Read and create the buttons.  After read the list of buttons, it create 
   * each button and them in the toolbar.
   */
  protected int readButton()
  {
    int nRetButtonValue = 0;
    
    if( m_toolbar != null )
    {
      String strButtonList = getParameter( kstrButtonDefName );
      String strButton = new String();
      
      if( strButtonList != null )
      {
        int nIndex = 0;
        int nPreviousIndex = 0;
        // Parse all string to find the n-1 button name
        while( ( nIndex = strButtonList.indexOf("|", nIndex++ ) ) != -1 )
        {
          strButton = strButtonList.substring( nPreviousIndex, nIndex );
          nRetButtonValue++;
          nIndex++;
          nPreviousIndex = nIndex;
          m_toolbar.createButton( strButton );
        }       
        // Take the last button.
        if( nPreviousIndex < strButtonList.length()-1 )
        {
          strButton = strButtonList.substring( nPreviousIndex );
          nRetButtonValue++;
          m_toolbar.createButton( strButton );
        }

      }
    }
    return nRetButtonValue;
  }

  
  
  /**
   * Select a default button in the toolbar and apply it in the command.
   * It will get the default button from the applet parameters.
   */
  protected void setSelectedButton()
  {
    // Read the selected button.
    String strDefaultButton = getParameter( kstrTbSelectedButton );
    if( strDefaultButton != null )
    {
      if( m_toolbar != null )
      {
        ButtonCtrl  defBut = m_toolbar.getButton( strDefaultButton );
        if( defBut != null )
        {
          defBut.setPressed( true );
          defBut.setCursorType();
          m_map.startAction( defBut, true );
        }
      }
    }
    
  }
  /**
   * Show the text pass in parameter in the status bar.  Later, most of the
   * string will be show in a tooltip object.
   */
  public void showText( String strText )
  {
    showStatus( strText );  
  }
  //////////////////////////////////////////////////////////
  // Method to paint image in window. 
  /**
   * Paint the applet. This method is called when the contents of the component 
   * should be painted in response to the component first being shown or damage 
   * needing repair.
   * 
   * @param g The graphics context to use for painting. 
   */
  public void paint(Graphics g) 
  {
    if( m_bLoad == false && m_strLoadingString != null)
    {   // Draw the loading string in the center of the applet.
      Dimension appletDim = getSize();
      int nX = (appletDim.width - g.getFontMetrics().stringWidth( m_strLoadingString ) ) / 2;
      
      g.setColor(new Color(255, 255, 255));
      
      g.fillRect(nX -2 , appletDim.height / 2 - g.getFontMetrics().getHeight(),
                 g.getFontMetrics().stringWidth( m_strLoadingString) + 2, 
                 g.getFontMetrics().getHeight()+4);
      g.setColor(new Color(0, 0, 0));
      g.drawString( m_strLoadingString, nX, appletDim.height / 2 );
    }
    else
    {   // Draw all visible components.
      super.paint( g );
    }
  }   

    public void printAll(Graphics g)
    {
	boolean bIsNetscape = true;
	
	// there is a bug while printing toolbar in netscape. For
	// now, I just skip the printing procees in netscape only
	// for toolbar.
	try 
	{
	    Class.forName("netscape.applet.MozillaAppletContext");
	} 
	catch (ClassNotFoundException e) 
	{ 
	    bIsNetscape = false;
	}

	if (bIsNetscape)
	{
	    m_map.print(g);

	    //m_toolbar.printAll(g);
	}
	else
	    super.printAll(g);
    }

  //////////////////////////////////////////////////////////////////////////////////
  // Loading window management
  //////////////////////////////////////////////////////////////////////////////////
  /**  
   * Display the loading message in a frame window. The title of the
   * window is the string came from the parameter LOADING_MSG.
   */
  void showLoadingMessage()
  {
    if( m_Frame == null && m_strLoadingString != null )
    {
      // Create the new frame.
      m_Frame = new Frame ();
      m_Frame.setLayout( null );

      // Set the size and the location of the window
      m_Frame.setSize( m_nWidthOfLoadingWnd, m_nHeightOfLoadingWnd );
      m_Frame.setTitle( m_strLoadingString );
      center( m_Frame );
      m_Frame.toFront();
      
      // Create the associated label.
      m_status = new Label ("");
      m_status.setSize( m_nWidthOfLoadingWnd, m_nHeightOfLoadingWnd );
      m_status.setAlignment( Label.CENTER );
      m_Frame.add(m_status);

      m_Frame.setResizable( false );

      m_status.setForeground(Color.blue);
      
      // Initialise the message.
      setLoadingMsg("" );
      
      // Show the window
      m_Frame.setVisible( true );
      
    }
    
  }

  /**
   * Set a string into the loading window.
   * 
   * @param strMsg String to draw in the window
   */
  protected void setLoadingMsg( String strMsg )
  {
    if( m_status != null )
    {
      m_status.setText( strMsg );
    }
  }

  /**
   * Destroy the loading message window.
   */
  protected void destroyLoadingMsg()
  {
    if( m_Frame != null )
    {
      m_Frame.setVisible( false );
      m_Frame.dispose();
      m_Frame = null;
      m_status = null; 
    }
  }
  
  /**
   * Center in the screen the window passed in the parameter.  
   * 
   * @param w Window to center.
   */
    public static void center(Window w) 
    { 
    // Get the screen size.
        Dimension screenSize		= Toolkit.getDefaultToolkit().getScreenSize(); 
        Dimension frameSize		= w.getSize(); 

        if (frameSize.height > screenSize.height) 
          frameSize.height = screenSize.height; 
        if (frameSize.width > screenSize.width) 
          frameSize.width = screenSize.width; 
    
        w.setLocation((screenSize.width - frameSize.width) / 2, 
                      (screenSize.height - frameSize.height) / 2); 
    }

   /**
   * Uses an URL to get various informations that can be used to
   * update the applet and set the FORM parameters.
   * Theese informations can be javascript functions, form paremetrs and
   * values, and also a new image to be displayed by the applet (MAPURL).
   * Here is the syntax that is expected :
   *     JAVASCRIPT
   *     javscript command
   *     javscript command
   *     ....
   *     END
   *     FORMPARMS
   *     form_param_name=form_param_value
   *     form_param_name=form_param_value
   *     ....
   *     END
   *     MAPURL=url
   * 
   *  How they are treated :
   *
   *    - all lines inside the delimiters JAVSCRIPT/END are assumed to be 
   *      javscript commands and are executed as is. For example if we
   *      want to call a javascript function myfunction(paramter) from 
   *      the applet (defined or accessible in th HTML file), we could pass a
   *      line like : myfunction(parameter) and this function will be called.
   *
   *    - all lines inside the delimiters FORMPARAMS are assumed to have
   *      the following syntax : parameter_name=new_value. The form parameter
   *      called parameter_name will be assigned a new value (new_value)
   *
   *   - the MAPURL parameter is used to replace the current image of the
   *     applet with a new one. Syntax is MAPURL=url.
   *
   * @param w Window to center.
   */

    public void SetMapInformations(String strURL)
    {
        //if (isDebugMode())
          System.out.println("SetMapInformations " + strURL);
          //System.out.println("Sizeofstring = " + strURL.length());


        Object oObject = null;
        InputStream oStream = null;
        String retval = "";
                
        if (strURL != null)
        {
            try
            {    
                URL url = null;
                URL urlbase =  getDocumentBase();
                
                try
                {
                    //url = new URL(strURL);
                    url = new URL(urlbase.getProtocol(), urlbase.getHost(), urlbase.getPort(), strURL);
                    
                }
                catch (Exception e)
                {
                    System.err.println("Error in SetMapInformations : url could not be created : " + url.toString());
                     System.exit(1);
                }

                //System.out.println("url : " + url.toString());
                oStream = url.openStream();
                
            }
            catch(Exception e)
            {
                System.err.println("Error in SetMapInformations");
                System.exit(1);
            }
        } 
        
        if (oStream != null)
        {
            try 
            {
                int nbytes = 0;
                int nSizeofBuffer = m_gBufferSizeForStream;
                byte buf[] = new byte[nSizeofBuffer];
                while( (nbytes = oStream.read( buf, 0, nSizeofBuffer)) != -1 ) 
                {
                    //retval += new String( buf, 0, 0, nbytes );
                    retval +=  new String(buf);
                }
                oStream.close();

            }
            catch(Exception e)
            {
                System.err.println("Error in SetMapInformations read");
                System.exit(1);
            }

            if (isDebugMode())
              System.out.println("SetMapInformations : stream value " + retval);
             
            StringTokenizer st = new StringTokenizer(retval, "\n");
            int i = 0;
            boolean bFormParm = false;
            boolean bJavaScript = false;
            while (st.hasMoreTokens()) 
            {
                String sToken = st.nextToken();
                if (isDebugMode())
                    System.out.println("Token = " + sToken);
                if (sToken.equalsIgnoreCase(new String("FORMPARAMS")))
                {
                    bFormParm = true;
                    continue;
                }
                if (sToken.equalsIgnoreCase(new String("JAVASCRIPT")))
                {
                    bJavaScript = true;
                    continue;
                }
                if (sToken.equalsIgnoreCase(new String("END")))
                {
                    bFormParm = false;
                    bJavaScript = false;
                    continue;
                }
                    
                if (sToken.regionMatches(true, 0, new String("MAPURL"), 0, 6))
                {
                    StringTokenizer stTmp = new StringTokenizer(sToken, "=");
                    if (stTmp.countTokens() == 2)
                    {
                         stTmp.nextToken();
                         String strNewURL = stTmp.nextToken();
                         loadMap(strNewURL);
                         continue;
                    }
                }
                
                if (bFormParm)
                {
                    String strParam = null;
                    String strValue = null;
                        
                    StringTokenizer stForm = new StringTokenizer(sToken, "=");
                    if (stForm.countTokens() == 2)
                    {
                        strParam = stForm.nextToken();
                        strValue = stForm.nextToken();
                        setFormParameter(strParam, strValue);
                    }
                }

                if (bJavaScript)
                {
                    JSObject.getWindow(this).eval(sToken);
                }
                
            }//end of while (st.hasMoreTokens()) 
        }

    }//end of loadMapInfo

   /**
   * Set parameters used in the FORM (HTML FORM tag) to a value passed
   * in parameter. It is expected that these parameters exist inm the 
   * FORM.
   */
    protected void  setFormParameter(String sParamName , String sValue)
    {
        if (isDebugMode())
            System.out.println("Setform param :" + sParamName + "=" + sValue);
        if (sParamName != null && sValue != null)
        {
            try
            {
                // get the string submit
                JSObject window = JSObject.getWindow(this);
                JSObject doc = (JSObject)window.getMember("document");
                if (doc != null)
                {
                    String strFormName = getParameter(kstrFormParam );
                    
                    if (strFormName != null)
                    {
                        JSObject form = (JSObject)doc.getMember(strFormName);
                        if(form != null)
                        {
                            JSObject jsParam = (JSObject)form.getMember(sParamName);
                            if (jsParam != null)
                              jsParam.setMember("value", sValue);
                            else
                              System.out.println("param not found");
                        }
                    }
                }
            }
            catch( java.lang.ClassCastException ex )
            {
                System.err.println( "A parameter is not found"); 
            }
        }
    }//end of setFormParameter()

   /**
   * Set the given button to pressed state. All other buttons are unpressed
   */
    public void setButtonPress(String strButton)
    {
        ButtonCtrl oButton = getButton(strButton);
        if (oButton != null  && m_toolbar != null)
        {
            m_toolbar.setButtonPress(oButton);
            m_map.startAction(oButton, true );
        }
    }

    /**
    * Return the ButtonCtrl object using the button name. 
    */
    public ButtonCtrl getButton(String strButton)
    {
        if (m_toolbar != null)
          return m_toolbar.getButton(strButton);

        return null;
    }

    /**
    * Allows to change the current image by giving a new URL to
    * the applet.
    */
    public void SetImageURL(String sURL)
    {
        System.out.println("SetImageURL " + sURL);

        if (sURL != null)
        {
            loadMap(sURL);
        }
    }
    
    
    /**
    * Allows to set the pixel size for the ruler function.
    */
    public void SetPixelSize(double dfPixelSize)
    {
        mdfPixelSize = dfPixelSize;
    }

    /** 
     * Returns the pixel size user for the ruler function
     */
    public double GetPixelSize()
    {
        return mdfPixelSize;
    }
}//end of Rosa2000

